local buyall_plugin = {}
buyall_plugin.visited_station = ""

local function exists_in_ship_cargo(name)
   for _,item in ipairs(GetShipInventory(GetActiveShipID()).cargo) do
      if GetInventoryItemName(item) == name then
	 return true
      end
   end
   return false
end

local function buy_one_for_all_f(_, args) 

   if PlayerInStation() == false then
      print("\127ffffffDock first")
      return
   end

   local ok_to_buy = false

   if args and args[1] ~= nil  then
      if args[1] == "yes" then
	 if buyall_plugin.visited_station == ShortLocationStr(GetCurrentSectorid()) then
	    ok_to_buy = true
	    buyall_plugin.visited_station = ""
	 else
	    print("\127ffffffPlease, run /buyall without params first")
	    return
	 end
      end
   end

   if buyall_plugin.confirmed and buyall_plugin.confirmed_station == ShortLocationStr(GetCurrentSectorid()) then
      ok_to_buy = true
   end

   local count = 0
   local tot_price = 0
   local tot_volume = 0
   local free_cargo_space = GetActiveShipMaxCargo() - GetActiveShipCargoCount()
   for i = 1, GetNumStationMerch() do 
      local item = GetStationMerchInfo(i)
      if item.type == "commodities" and not exists_in_ship_cargo(item.name) then
	 -- item is trade item and does not exist in ship cargo
	 item.longdesc = ""
	 item.extendeddesc = ""
	 --print(dprint(item))
	 if ok_to_buy then
	    if free_cargo_space >= item.volume  then
	       PurchaseMerchandiseItem(item.itemid, 1, function() end)
	       free_cargo_space = free_cargo_space - item.volume
	    else
	       print("\127ff6600  ** Not enough free cargo space (bought "..count.." items)")
	       ProcessEvent("ENTERED_STATION", {dontdo=true})
	       return
	    end
	 end
	 count = count + 1
	 tot_price = tot_price + item.price
	 tot_volume = tot_volume + item.volume
      end
   end

   if not ok_to_buy then
      print("\127ffffffBuyall: ".."total items: "..count.." total tot_price: "..tot_price.." total need of cargo space: "..tot_volume)
      if tot_volume > free_cargo_space then
	 print("\127ff6600** Not enough free cargo space (free space = "..free_cargo_space..")")
      end
      print("\127ffffff** Confirm with /buyall yes")

      buyall_plugin.visited_station = ShortLocationStr(GetCurrentSectorid())
   else
      if ok_to_buy then
	 print("\127ffffffBuyall: "..count.." items were bought")
	 ProcessEvent("ENTERED_STATION", {dontdo=true})
      end
   end
end
RegisterUserCommand("buyall", buy_one_for_all_f)